#include <iostream>
#define MAXN 200010
#define MOD 1000000007
using namespace std;
long long a[MAXN];
int main()
{
    long long n,k,z=0;
    cin >> n >> k;
    for (long long i=0;i<n;i++)
    {
        cin >> a[i];
        z+=(a[i]%MOD);
        z%=MOD;
    }
    if (k==0)
    {
        cout << z << "\n";
        return 0;
    }
    if (k==1)
    {
        long long x=0,y=1,rez=0;
        for (long long i=0;i<n;i++)
        {
            rez+=((a[i]%MOD)*((n-x)%MOD)*(y%MOD))%MOD;
            rez%=MOD;
            x++;
            y++;
        }
        cout << rez << "\n";
    }
    return 0;
}